/*
Must move static with button on fancy buttons
Ctrl - Left button should tag/untag
Want tagmode off to restore screen properly
Allow sizing of Says.
*/


#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.CH"

* -------------

STATIC CLASS Designer

EXPORTED:
VAR sourceCodeFile
VAR sourceCodeString
VAR designMode
VAR coords
VAR allowResize
VAR tagMode
VAR xbpTaggedArray
VAR xbp
VAR getListObject
VAR getListArray
VAR pos
VAR size
VAR lastXbp
VAR trackSource
VAR editor
VAR paintObject
VAR paintCoords

INLINE METHOD Init( aGetList )

::getListArray := aGetList
::designMode := .f.
::xbpTaggedArray := Array(0)
::allowResize := .f.
::coords := Array(8)
::tagMode := .F.
::trackSource := .f.
IF IsFunction('DC_Sett')
  ::editor := Pad(&("DC_Sett('EDITOR')"),50)
ELSE
  ::editor := Space(50)
ENDIF
RETURN self

ENDCLASS

* -------------

FUNCTION DC_DesignHandler( nEvent, mp1, mp2, oXbp, oDlg, aGetList )

LOCAL nDataStore, oGetList, cSourceLine, nPointer, GetList[0], oMenu, i, ;
      GetOptions

STATIC soDesigner, saStatic[10], soDialog

IF Valtype( soDesigner ) # 'O'
  soDesigner := Designer():new()
ENDIF

IF nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ALT_F1

  nDataStore := AScan(aGetList,{|a|a[nGETLIST_TYPE]==GETLIST_DATASTORE})
  IF nDataStore > 0
    soDesigner:getListArray := aGetList
    soDesigner:getListObject := aGetList[nDataStore,oGETLIST_OBJECT]
    soDesigner:sourceCodeFile := ;
      Alltrim(DC_XtoC(soDesigner:getListObject:getOptions[cGETOPT_SOURCECODE]))
    soDesigner:designMode := !soDesigner:designMode
    IF soDesigner:designMode
      IF Empty(soDesigner:sourceCodeFile)
        DCMSGBOX 'No SOURCEFILE defined in DCGETOPTIONS', ;
                 'It must be defined to use design mode'
        RETURN DCGUI_IGNORE
      ELSEIF !File( soDesigner:sourceCodeFile )
        DCMSGBOX 'SOURCEFILE defined in DCGETOPTIONS does not exist:', ;
                  soDesigner:sourceCodeFile, ;
                 'It must already exist to use design mode'
        RETURN DCGUI_IGNORE
      ENDIF
      soDesigner:designMode := .f.
      @ 0,0 DCSAY ;
             'Use the Left Mouse Button to SELECT an object.;' + ;
             'Use the Arrow Keys to MOVE the object.;' + ;
             'Use the CTRL Arrow Keys to Resize the object.;' + ;
             'Use the SHIFT Arrow Keys to Fast-MOVE the object.;' + ;
             'Use the Middle Mouse Button to Set the Cross-Hair.;' + ;
             'Use the ALT Arrow Keys to Snap object to Cross-Hair.' ;
            SAYSIZE 60,4 SAYWORDBREAK

      saStatic := Array(10)

      @ 4,10 DCSAY 'Focus Object' SAYSIZE 25 SAYFONT '10.Arial Bold Italic'
      @ 4,35 DCSAY 'Mouse Object' SAYSIZE 25 SAYFONT '10.Arial Bold Italic'

      @ 5,0 DCSAY '   Row:'
      @ DCGUI_ROW, DCGUI_COL DCSAY '' OBJECT saStatic[1] SIZE 25 FONT '10.Courier Bold'
      @ DCGUI_ROW, DCGUI_COL DCSAY '' OBJECT saStatic[6] SIZE 25 FONT '10.Courier Bold'

      @ 6,0 DCSAY '   Col:'
      @ DCGUI_ROW, DCGUI_COL DCSAY '' OBJECT saStatic[2] SIZE 25 FONT '10.Courier Bold'
      @ DCGUI_ROW, DCGUI_COL DCSAY '' OBJECT saStatic[7] SIZE 25 FONT '10.Courier Bold'

      @ 7,0 DCSAY ' Width:'
      @ DCGUI_ROW, DCGUI_COL DCSAY '' OBJECT saStatic[3] FONT '10.Courier Bold'

      @ 8,0 DCSAY 'Height:'
      @ DCGUI_ROW, DCGUI_COL DCSAY '' OBJECT saStatic[4] FONT '10.Courier Bold'

      @ 9.5,0 DCSAY ' Class:'
      @ DCGUI_ROW, DCGUI_COL DCSAY '' OBJECT saStatic[5] SAYSIZE 25 FONT '10.Courier Bold'
      @ DCGUI_ROW, DCGUI_COL DCSAY '' OBJECT saStatic[8] SIZE 25 FONT '10.Courier Bold'

      @ 11, 0 DCCHECKBOX soDesigner:trackSource PROMPT 'Track Source in Editor'
      @ 12, 0 DCSAY 'Source Code Editor' GET soDesigner:editor ;
              ;// WHEN {||soDesigner:trackSource} ;
              GETSIZE 20 SAYSIZE 0 SAYBOTTOM

      @ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Alt-F1 / Cancel' SIZE 12,1.2 ;
         ACTION {||PostAppEvent(xbeP_Keyboard, xbeK_ALT_F1,,soDialog)}

      DCGETOPTIONS SAYWIDTH 60 SAYFONT '9.Courier' SAYBOTTOM
      DCREAD GUI FIT TITLE 'Design Mode is ON' PARENT @soDialog EXIT OPTIONS GetOptions
      soDesigner:designMode := .t.
    ELSE
      DCMSGBOX 'Design Mode is OFF'
      SaveToSourceString( soDesigner, soDesigner:lastXbp )
      IF !Empty(soDesigner:xbpTaggedArray)
        ToggleTagMode(soDesigner)
      ENDIF
      saStatic := nil
      soDialog:destroy()
      soDialog := nil
    ENDIF

    IF soDesigner:designMode
      soDesigner:sourceCodeString := MemoRead(soDesigner:sourceCodeFile)
      MemoWrit( Strtran(Upper(soDesigner:sourceCodeFile),'.PRG','.BAK'),soDesigner:sourceCodeString )
    ELSEIF !Empty(soDesigner:sourceCodeString) .AND. ;
      DC_MsgBox(,,{'Save source code changes to', ;
                   soDesigner:sourceCodeFile + ' ?'},'Save Source',,,.t.)
      MemoWrit( soDesigner:sourceCodeFile, soDesigner:sourceCodeString )
    ENDIF

  ENDIF

ELSEIF nEvent == xbeM_Motion .AND. soDesigner:designMode .AND. ;
      !DC_IsDescendant(oXbp,soDialog)

  IF Valtype(oXbp:cargo) == 'A' .AND. Valtype(oXbp:cargo[1]) == 'N' .AND. oXbp:cargo[1] > 0
    nPointer := oXbp:cargo[1]
    _GetCoords( aGetlist, nPointer, oXbp, soDesigner:getListObject, saStatic, mp1, 2 )
  ELSE

  ENDIF

ELSEIF nEvent == xbeM_RbDown .AND. soDesigner:designMode .AND. ;
      !DC_IsDescendant(oXbp,soDialog)

  DCSUBMENU oMenu PROMPT 'Menu'
  DCMENUITEM 'Tag Mode ' + IIF( soDesigner:tagMode,'OFF','ON') PARENT oMenu ;
      ACTION {||ToggleTagMode(soDesigner)}
  DCREAD GUI EXIT PARENT AppDeskTop()
  oMenu:popup( oXbp, mp1, 2, XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN )

ELSEIF nEvent == xbeM_LbDown .AND. soDesigner:designMode .AND. ;
      !DC_IsDescendant(oXbp,soDialog)

  IF oXbp:isDerivedFrom('XbpCellGroup')
    oXbp := oXbp:setParent():setParent():setParent():setParent() // point to Browse object
  ENDIF

  IF oXbp:isDerivedFrom('XbpDialog') .OR. ;
     oXbp:isDerivedFrom('XbpIWindow') .OR. ;
     oXbp:isDerivedFrom('XbpScrollBar')
     RETURN DCGUI_NONE
  ENDIF

  IF ;
     ;//(Empty(soDesigner:lastXbp) .OR. !(oXbp == soDesigner:lastXbp)) .AND. ;
      IsGetListObject( oXbp, soDesigner:getListArray )

    IF Valtype(soDesigner:lastXbp) == 'O'
      DC_HiliteGets( soDesigner:lastXbp, 2, GRA_CLR_RED )
      SaveToSourceString( soDesigner, soDesigner:lastXbp )
    ENDIF
    DC_HiliteGets( oXbp, 1, GRA_CLR_RED )
    SetObject( soDesigner, oXbp )
    soDesigner:lastXbp := oXbp
    soDesigner:xbp := oXbp
    IF Valtype(oXbp:cargo) == 'A' .AND. Valtype(oXbp:cargo[1]) == 'N' .AND. oXbp:cargo[1] > 0
      nPointer := oXbp:cargo[1]
      _GetCoords( aGetlist, nPointer, oXbp, soDesigner:getListObject, saStatic, mp1, 1 )
    ENDIF
  ENDIF

  RETURN DCGUI_IGNORE

ELSEIF nEvent = xbeM_MbDown .AND. soDesigner:designMode .AND. ;
      !DC_IsDescendant(oXbp,soDialog)

  IF !Empty(soDesigner:paintObject)
    soDesigner:paintObject:paint := nil
    soDesigner:paintObject:invalidateRect()
  ENDIF
  soDesigner:paintObject := oXbp
  soDesigner:paintCoords := mp1
  soDesigner:paintObject:paint := {||PaintCrossHair(soDesigner)}
  RETURN DCGUI_IGNORE

ELSEIF soDesigner:designMode .AND. Valtype(soDesigner:xbp) == 'O' .AND. nEvent == xbeP_Keyboard ;
       .AND. !(oXbp:setParent() == soDialog:drawingArea)

  DC_HiliteGets( soDesigner:xbp, 2, GRA_CLR_RED )
  IF !Empty(soDesigner:xbpTaggedArray)
    FOR i := 1 TO Len(soDesigner:xbpTaggedArray)
      MoveObject( soDesigner, soDesigner:xbpTaggedArray[i], mp1 )
    NEXT
  ELSEIF !Empty(soDesigner:xbp)
    DC_HiliteGets( soDesigner:xbp, 2, GRA_CLR_RED )
    MoveObject( soDesigner, soDesigner:xbp, mp1 )
    DC_HiliteGets( soDesigner:xbp, 1, GRA_CLR_RED )
  ENDIF

  RETURN DCGUI_IGNORE

ENDIF

RETURN DCGUI_NONE

* ------------------------

STATIC FUNCTION ToggleTagMode( oDesigner )

LOCAL i

oDesigner:tagMode := !oDesigner:tagMode

FOR i := 1 TO Len(oDesigner:xbpTaggedArray)
  oDesigner:xbpTaggedArray[i]:setColorBG(GRA_CLR_WHITE)
  SaveToSourceString( oDesigner, oDesigner:xbpTaggedArray[i])
NEXT

ASize(oDesigner:xbpTaggedArray,0)

RETURN nil

* ------------------------

STATIC FUNCTION SaveToSourceString( oDesigner, oXbp )

LOCAL oXbpSave, nPointer, cSourceLine, aGetList := oDesigner:getListArray, ;
      nStartPos, nEndPos, nFound

IF Valtype(oXbp) == 'O' .AND. IsGetListObject(oXbp,aGetList)

  oXbpSave := oXbp
  IF oXbpSave:isDerivedFrom('DC_XbpGet') .AND. Valtype(oXbpSave:sayObject) == 'O'
    oXbpSave := oXbpSave:sayObject
  ENDIF

  nPointer := oXbpSave:cargo[1]

  _SaveGetCoords( aGetlist, nPointer, oXbpSave, oDesigner:getListObject )

  IF Valtype(aGetList[nPointer,aGETLIST_PROC]) # 'A'

    DC_WinAlert('Cannot find line and procedure in source code!' + Chr(13)+Chr(10) + ;
                'Make sure to compile your source with latest version of DCDIALOG.CH')

  ELSE

    oDesigner:coords[2] := oDesigner:xbp:currentPos()[1]
    oDesigner:coords[4] := oDesigner:xbp:currentPos()[2]
    oDesigner:coords[6] := oDesigner:xbp:currentSize()[1]
    oDesigner:coords[8] := oDesigner:xbp:currentSize()[2]

    cSourceLine := DC_SourceRead( oDesigner:sourceCodeString, ;
                                  aGetList[nPointer,aGETLIST_PROC,2], ;
                                  @nStartPos, @nEndPos )

    cSourceLine := DC_SourceRepl( cSourceLine, ;
                                  aGetList[nPointer,nGETLIST_STARTROW], ;
                                  aGetList[nPointer,nGETLIST_STARTCOL], ;
                                  aGetList[nPointer,nGETLIST_WIDTH], ;
                                  aGetList[nPointer,nGETLIST_HEIGHT], ;
                                  aGetList[nPointer,nGETLIST_TYPE], ;
                                  oDesigner:coords )

    oDesigner:sourceCodeString := DC_SourceWrite( oDesigner:sourceCodeString, ;
                                                  cSourceLine, nStartPos, nEndPos )

  ENDIF

ENDIF

RETURN nil

* ------------------------

STATIC FUNCTION SetObject( oDesigner, oXbp )

LOCAL i, nFound, nPointer, nLineNumber, aProc, oFocus, aChildList, ;
      lCtrlDown

lCtrlDown := AppKeyState(xbeK_CTRL) == 1

oDesigner:coords[1] := oXbp:currentPos()[1]
oDesigner:coords[3] := oXbp:currentPos()[2]
oDesigner:coords[5] := oXbp:currentSize()[1]
oDesigner:coords[7] := oXbp:currentSize()[2]
oDesigner:coords[2] := oXbp:currentPos()[1]
oDesigner:coords[4] := oXbp:currentPos()[2]
oDesigner:coords[6] := oXbp:currentSize()[1]
oDesigner:coords[8] := oXbp:currentSize()[2]

oDesigner:xbp := oXbp

IF oDesigner:tagMode .OR. lCtrlDown
  IF (nFound := AScan( oDesigner:xbpTaggedArray, oXbp )) > 0
    ARemove( oDesigner:xbpTaggedArray, nFound )
    oXbp:setColorBG(GRA_CLR_WHITE)
  ELSE
    AAdd( oDesigner:xbpTaggedArray, oXbp )
    oXbp:setColorBG(GRA_CLR_YELLOW)
  ENDIF
ELSE
  oDesigner:tagMode := .T.
  ToggleTagMode(oDesigner)
ENDIF

aChildList := oXbp:childList()
FOR i := 1 TO Len(aChildList)
  aChildList[i]:enable()
NEXT

IF oDesigner:trackSource
  nPointer := oXbp:cargo[1]
  aProc := oDesigner:getListArray[nPointer,aGETLIST_PROC]
  IF Valtype(aProc) = 'A' .AND. Len(aProc) = 2
    nLineNumber := aProc[2]
    IF Valtype(nLineNumber) = 'N' .AND. nLineNumber > 0 .AND. File(Alltrim(oDesigner:sourceCodeFile))
      oFocus := SetAppFocus()
      RunShell(Alltrim(oDesigner:sourceCodeFile) + ' ' + Alltrim(Str(nLineNumber)), ;
               Alltrim(oDesigner:editor),.t.,.t.)
      Sleep(50)
      SetAppFocus(oFocus)
      DC_ClearEvents()
    ENDIF
  ENDIF
ENDIF

RETURN nil

* ------------------------

STATIC FUNCTION MoveObject( oDesigner, oXbp, mp1 )

LOCAL i, nPixels, lReSize, oXbp2, oXbp3, aSavePos := oXbp:currentPos(), ;
      aChildren

oDesigner:allowResize := .f.
IF oXbp:isDerivedFrom('DC_XbpGet')
  IF Valtype(oXbp:popupButton) == 'O'
    oXbp2 := oXbp:popupButton
  ENDIF
  IF Valtype(oXbp:sayObject) == 'O'
    oXbp3 := oXbp:sayObject
  ENDIF
ELSEIF oXbp:isDerivedFrom('DC_XbpStatic') .AND. !oXbp:type == XBPSTATIC_TYPE_TEXT
  oDesigner:allowResize := .t.
ELSEIF oXbp:isDerivedFrom('DC_XbpTabPage') .OR. ;
       oXbp:isDerivedFrom('DC_XbpStatic') .OR. ;
       oXbp:isDerivedFrom('DC_XbpComboBox') .OR. ;
       oXbp:isDerivedFrom('DC_XbpMle') .OR. ;
       oXbp:isDerivedFrom('DC_XbpBrowse') .OR. ;
       (oXbp:isDerivedFrom('DC_XbpPushButton') .AND. !oXbp:setParent():isDerivedFrom('DC_XbpToolbar'))
  oDesigner:allowResize := .t.
ENDIF

nPixels := 1
lReSize := .f.

IF mp1 == xbeK_SH_UP
  mp1 := xbeK_UP
  nPixels := 10
ELSEIF mp1 == xbeK_SH_DOWN
  mp1 := xbeK_DOWN
  nPixels := 10
ELSEIF mp1 == xbeK_SH_RIGHT
  mp1 := xbeK_RIGHT
  nPixels := 10
ELSEIF mp1 == xbeK_SH_LEFT
  mp1 := xbeK_LEFT
  nPixels := 10
ELSEIF mp1 == xbeK_ALT_UP .AND. !Empty(oDesigner:paintObject) .AND. ;
       oXbp:setParent() == oDesigner:paintObject
  oXbp:setPos( { oXbp:currentPos()[1], oDesigner:paintCoords[2] } )
  IF Valtype(oXbp2) = 'O'
    oXbp2:setPos( { oXbp2:currentPos()[1], oXbp2:currentPos()[2] + oXbp:currentPos()[2]-aSavePos[2]})
  ENDIF
  IF Valtype(oXbp3) = 'O'
    oXbp3:setPos( { oXbp3:currentPos()[1], oXbp3:currentPos()[2] + oXbp:currentPos()[2]-aSavePos[2]})
  ENDIF
ELSEIF mp1 == xbeK_ALT_DOWN .AND. !Empty(oDesigner:paintObject) .AND. ;
       oXbp:setParent() == oDesigner:paintObject
  oXbp:setPos( { oXbp:currentPos()[1], oDesigner:paintCoords[2] - oXbp:currentSize()[2] } )
  IF Valtype(oXbp2) = 'O'
    oXbp2:setPos( { oXbp2:currentPos()[1], oXbp2:currentPos()[2] + oXbp:currentPos()[2]-aSavePos[2]})
  ENDIF
  IF Valtype(oXbp3) = 'O'
    oXbp3:setPos( { oXbp3:currentPos()[1], oXbp3:currentPos()[2] + oXbp:currentPos()[2]-aSavePos[2]})
  ENDIF
ELSEIF mp1 == xbeK_ALT_RIGHT .AND. !Empty(oDesigner:paintObject) .AND. ;
       oXbp:setParent() == oDesigner:paintObject
  oXbp:setPos( { oDesigner:paintCoords[1], oXbp:currentPos()[2] } )
  IF Valtype(oXbp2) = 'O'
    oXbp2:setPos( { oXbp2:currentPos()[1] + oXbp:currentPos()[1]-aSavePos[1], oXbp2:currentPos()[2]})
  ENDIF
  IF Valtype(oXbp3) = 'O'
    oXbp3:setPos( { oXbp3:currentPos()[1] + oXbp:currentPos()[1]-aSavePos[1], oXbp3:currentPos()[2]})
  ENDIF
ELSEIF mp1 == xbeK_ALT_LEFT .AND. !Empty(oDesigner:paintObject) .AND. ;
       oXbp:setParent() == oDesigner:paintObject
  oXbp:setPos( { oDesigner:paintCoords[1] - oXbp:currentSize()[1], oXbp:currentPos()[2] } )
  IF Valtype(oXbp2) = 'O'
    oXbp2:setPos( { oXbp2:currentPos()[1] + oXbp:currentPos()[1]-aSavePos[1], oXbp2:currentPos()[2]})
  ENDIF
  IF Valtype(oXbp3) = 'O'
    oXbp3:setPos( { oXbp3:currentPos()[1] + oXbp:currentPos()[1]-aSavePos[1], oXbp3:currentPos()[2]})
  ENDIF
ELSEIF mp1 == xbeK_CTRL_DOWN .AND. oDesigner:allowResize
  mp1 := xbeK_DOWN
  lReSize := .t.
ELSEIF mp1 == xbeK_CTRL_UP .AND. oDesigner:allowResize
  mp1 := xbeK_UP
  lReSize := .t.
ELSEIF mp1 == xbeK_CTRL_LEFT .AND. oDesigner:allowResize
  mp1 := xbeK_LEFT
  lReSize := .t.
ELSEIF mp1 == xbeK_CTRL_RIGHT .AND. oDesigner:allowResize
  mp1 := xbeK_RIGHT
  lReSize := .t.
ELSEIF mp1 == xbeK_SH_CTRL_DOWN .AND. oDesigner:allowResize
  mp1 := xbeK_DOWN
  lReSize := .t.
  nPixels := 10
ELSEIF mp1 == xbeK_SH_CTRL_UP .AND. oDesigner:allowResize
  mp1 := xbeK_UP
  lReSize := .t.
  nPixels := 10
ELSEIF mp1 == xbeK_SH_CTRL_LEFT .AND. oDesigner:allowResize
  mp1 := xbeK_LEFT
  lReSize := .t.
  nPixels := 10
ELSEIF mp1 == xbeK_SH_CTRL_RIGHT .AND. oDesigner:allowResize
  mp1 := xbeK_RIGHT
  nPixels := 10
  lReSize := .t.
ENDIF

IF lReSize

  IF mp1 == xbeK_UP
    oXbp:setSize( { oXbp:currentSize()[1], oXbp:currentSize()[2]+nPixels } )
    aChildren := oXbp:childList()
    FOR i := 1 TO Len(aChildren)
      aChildren[i]:setPos( { aChildren[i]:currentPos()[1], aChildren[i]:currentPos()[2] + nPixels } )
    NEXT
  ELSEIF mp1 == xbeK_DOWN
    oXbp:setSize( { oXbp:currentSize()[1], oXbp:currentSize()[2]-nPixels } )
    aChildren := oXbp:childList()
    FOR i := 1 TO Len(aChildren)
      aChildren[i]:setPos( { aChildren[i]:currentPos()[1], aChildren[i]:currentPos()[2] - nPixels } )
    NEXT
  ELSEIF mp1 == xbeK_RIGHT
    oXbp:setSize( { oXbp:currentSize()[1]+nPixels, oXbp:currentSize()[2] } )
  ELSEIF mp1 == xbeK_LEFT
    oXbp:setSize( { oXbp:currentSize()[1]-nPixels, oXbp:currentSize()[2] } )
  ENDIF

ELSE

  IF mp1 == xbeK_UP
    oXbp:setPos( { oXbp:currentPos()[1], oXbp:currentPos()[2]+nPixels } )
    IF Valtype(oXbp2) == 'O'
      oXbp2:setPos( { oXbp2:currentPos()[1], oXbp2:currentPos()[2]+nPixels } )
    ENDIF
    IF Valtype(oXbp3) == 'O'
      oXbp3:setPos( { oXbp3:currentPos()[1], oXbp3:currentPos()[2]+nPixels } )
    ENDIF
  ELSEIF mp1 == xbeK_DOWN
    oXbp:setPos( { oXbp:currentPos()[1], oXbp:currentPos()[2]-nPixels } )
    IF Valtype(oXbp2) == 'O'
      oXbp2:setPos( { oXbp2:currentPos()[1], oXbp2:currentPos()[2]-nPixels } )
    ENDIF
    IF Valtype(oXbp3) == 'O'
      oXbp3:setPos( { oXbp3:currentPos()[1], oXbp3:currentPos()[2]-nPixels } )
    ENDIF
  ELSEIF mp1 == xbeK_RIGHT
    oXbp:setPos( { oXbp:currentPos()[1]+nPixels, oXbp:currentPos()[2] } )
    IF Valtype(oXbp2) == 'O'
      oXbp2:setPos( { oXbp2:currentPos()[1]+nPixels, oXbp2:currentPos()[2] } )
    ENDIF
    IF Valtype(oXbp3) == 'O'
      oXbp3:setPos( { oXbp3:currentPos()[1]+nPixels, oXbp3:currentPos()[2] } )
    ENDIF
  ELSEIF mp1 == xbeK_LEFT
    oXbp:setPos( { oXbp:currentPos()[1]-nPixels, oXbp:currentPos()[2] } )
    IF Valtype(oXbp2) == 'O'
      oXbp2:setPos( { oXbp2:currentPos()[1]-nPixels, oXbp2:currentPos()[2] } )
    ENDIF
    IF Valtype(oXbp3) == 'O'
      oXbp3:setPos( { oXbp3:currentPos()[1]-nPixels, oXbp3:currentPos()[2] } )
    ENDIF
  ENDIF

ENDIF

IF !Empty(oDesigner:paintObject)
  oDesigner:paintObject:invalidateRect()
ENDIF

RETURN nil

* ------------------------

STATIC FUNCTION _SaveGetCoords( aGetList, nPointer, oXbp, oGetList )

LOCAL aGetOptions := oGetList:getOptions, ;
      nHeight, nWidth, nStartRow, nStartCol, nParentHeight, ;
      nRowPixels := aGetOptions[nGETOPT_ROWSPACE], ;
      nColPixels := aGetOptions[nGETOPT_COLPIXELS], ;
      nFitPad := aGetOptions[nGETOPT_FITPAD], ;
      nOffset := 0, ;
      lIsFit := oGetList:isFit

DEFAULT nFitPad := 10

IF oXbp:setParent():isDerivedFrom('XbpIWindow')
  nOffset := 7
ENDIF
nStartCol := oXbp:CurrentPos()[1]
nStartRow := oXbp:CurrentPos()[2]
nWidth    := oXbp:CurrentSize()[1]
nHeight   := oXbp:CurrentSize()[2]
nParentHeight := oXbp:setParent():CurrentSize()[2]
IF !Empty(aGetlist[nPointer,bGETLIST_PARENT]) .OR. !lIsFit
  nFitPad := 0
ENDIF

IF !(aGetOptions[lGETOPT_TRANSLATE])
  aGetlist[nPointer,nGETLIST_STARTCOL] := nStartCol - nFitPad
  aGetlist[nPointer,nGETLIST_STARTROW] := nStartRow - nFitPad
  aGetlist[nPointer,nGETLIST_WIDTH]    := nWidth
  aGetlist[nPointer,nGETLIST_HEIGHT]   := nHeight
ELSEIF aGetList[nPointer,lGETLIST_PIXEL] .OR. aGetOptions[lGETOPT_PIXEL]
  aGetlist[nPointer,nGETLIST_WIDTH]    := nWidth
  aGetlist[nPointer,nGETLIST_HEIGHT]   := nHeight
  aGetlist[nPointer,nGETLIST_STARTCOL] := nStartCol - nFitPad
  aGetlist[nPointer,nGETLIST_STARTROW] := nParentHeight - nStartRow - nHeight - nFitPad
ELSE
  aGetlist[nPointer,nGETLIST_HEIGHT]   := oXbp:CurrentSize()[2] / nRowPixels
  aGetlist[nPointer,nGETLIST_WIDTH]    := oXbp:CurrentSize()[1] / nColPixels
  aGetlist[nPointer,nGETLIST_STARTROW] := ((nParentHeight - nStartRow - nFitPad - nOffset - nHeight ) / nRowPixels)
  aGetlist[nPointer,nGETLIST_STARTCOL] := ( (nStartCol - nFitPad) / nColPixels )
ENDIF

RETURN nil

* ------------------------

STATIC FUNCTION _GetCoords( aGetList, nPointer, oXbp, oGetList, aStatic, mp1, nMode )

LOCAL aGetOptions := oGetList:getOptions, ;
      nHeight, nWidth, nStartRow, nStartCol, nParentHeight, ;
      nRowPixels := aGetOptions[nGETOPT_ROWSPACE], ;
      nColPixels := aGetOptions[nGETOPT_COLPIXELS], ;
      nFitPad := aGetOptions[nGETOPT_FITPAD], ;
      nOffset := 0, ;
      lIsFit := oGetList:isFit, ;
      nMouseRow := 0, nMouseCol := 0

DEFAULT nFitPad := 10

IF oXbp:setParent():isDerivedFrom('XbpIWindow')
  nOffset := 7
ENDIF
nStartCol := oXbp:CurrentPos()[1]
nStartRow := oXbp:CurrentPos()[2]
nWidth    := oXbp:CurrentSize()[1]
nHeight   := oXbp:CurrentSize()[2]
nParentHeight := oXbp:setParent():CurrentSize()[2]
IF !Empty(aGetlist[nPointer,bGETLIST_PARENT]) .OR. !lIsFit
  nFitPad := 0
ENDIF
IF !aGetOptions[lGETOPT_TRANSLATE]
  nStartCol := nStartCol - nFitPad
  nStartRow := nStartRow - nFitPad
  nWidth    := nWidth
  nHeight   := nHeight
  nMouseRow := mp1[2]
  nMouseCol := mp1[1]
ELSEIF aGetList[nPointer,lGETLIST_PIXEL] .OR. aGetOptions[lGETOPT_PIXEL]
  nWidth    := nWidth
  nHeight   := nHeight
  nStartCol := nStartCol - nFitPad
  nStartRow := nParentHeight - nStartRow - nHeight - nFitPad
  nMouseRow := nHeight - mp1[2] - nFitPad
  nMouseCol := mp1[1] - nFitPad
ELSE
  nHeight   := oXbp:CurrentSize()[2]
  nWidth    := oXbp:CurrentSize()[1]
  nStartRow := ((nParentHeight - nStartRow - nFitPad - nOffset - nHeight ) / nRowPixels)
  nStartCol := ( (nStartCol - nFitPad) / nColPixels )
  nMouseRow := ((nHeight - mp1[2] - nFitPad - nOffset ) / nRowPixels)
  nMouseCol := ( (mp1[1] - nFitPad) / nColPixels )
  nHeight   := nHeight / nRowPixels
  nWidth    := nWidth / nColPixels
ENDIF

IF nMode = 1
  aStatic[1]:setCaption(Str(nStartRow,4))
  aStatic[2]:setCaption(Str(nStartCol,4))
  aStatic[3]:setCaption(Str(nWidth,4))
  aStatic[4]:setCaption(Str(nHeight,4))
  aStatic[5]:setCaption(oXbp:ClassName())
ELSE
  aStatic[6]:setCaption(Str(nMouseRow,4))
  aStatic[7]:setCaption(Str(nMouseCol,4))
  aStatic[8]:setCaption(oXbp:ClassName())
ENDIF

RETURN nil

* ----------------

STATIC FUNCTION PaintCrossHair( oDesigner )

LOCAL oPs := oDesigner:paintObject:lockPs(), aPos := oDesigner:paintCoords, ;
      nCol, nRow, aLineAttr[GRA_AL_COUNT]

nCol := aPos[1]
nRow := aPos[2]

aLineAttr[GRA_AL_COLOR] := GRA_CLR_CYAN
GraSetAttrLine( oPs, aLineAttr )
GraLine( oPs, { nCol - 1000, nRow }, { nCol + 1000, nRow } )
GraLine( oPs, { nCol, nRow - 1000 }, { nCol, nRow + 1000 } )

oDesigner:paintObject:unLockPs(oPS)

RETURN nil

* -----------------

STATIC FUNCTION IsGetListObject( oXbp, aGetList )

RETURN AScan( aGetList,{|a|Valtype(a[oGETLIST_OBJECT])=='O'.AND.a[oGETLIST_OBJECT]==oXbp } ) > 0
